/////////////////////////////////////////////////////////////////////////
/////////////             LoopMotion            /////////////////////////
//////////////////////////////////////////////////////////////////////////
boolean loopMotion() // move one increment towards targetXYZ at constant speed
{
  float dx,dy,dz, dt, scale, distance, now;



  dx = targetX - currX;
  dy = targetY - currY;
  dz = targetZ - currZ;
 
  distance = sqrt( (dx*dx) + (dy*dy) + (dz*dz));

  if( distance < 1 ) // arrived
  {
    finitoMvto=true;
    return false;
  }

  now = millis();
  dt =  now - currT;

  if( inBrakingZone(distance))
  {
    currSpeed -= acceleration * dt;
    if( currSpeed < minSpeed )
      currSpeed = minSpeed;
  }
  else if( currSpeed < maxSpeed )
  {
    currSpeed += acceleration * dt;

    if( currSpeed > maxSpeed )
      currSpeed = maxSpeed;
  }

  scale = dt * currSpeed / distance;
  
  dx = scale * dx;
  dy = scale * dy;
  dz = scale * dz;
  currX += dx;
  currY += dy;
  currZ += dz;
  
  currT = now;

  
  goTo( currX, currY, currZ );

  Serial.print(" X:"); 
  Serial.print(currX);
  Serial.print(" Y:");  
  Serial.print(currY);
  Serial.print(" Z:");
  Serial.print(currZ);
  Serial.print(" Correz:");
  Serial.print(correz);
  Serial.print(" T1:");
  Serial.print(t1); 
  Serial.print(" T2:");
  Serial.print(t2); 
  Serial.print(" T3:");
  Serial.println(t3);   
  finitoMvto = false;
  return true;
}


/////////////////////////////////////////////////////////////////////////
/////////////            inBrakingZone          /////////////////////////
//////////////////////////////////////////////////////////////////////////
boolean inBrakingZone( float distance )
{
  // s = 0.5 a t^2
  // s = 0.5 v t
  // => s = v^2 / 2a
  float s = currSpeed * currSpeed * 0.5 / acceleration;
  return distance < s;
}


/////////////////////////////////////////////////////////////////////////
/////////////             MoveTo                /////////////////////////
//////////////////////////////////////////////////////////////////////////
void moveTo( float x0, float y0, float z0, int v0 )
{
  targetX = x0;
  targetY = y0;
  targetZ = z0;
  currSpeed = 0;
  vChange = 1;
  targetV = v0;

  if (currV == targetV)
    vChange=0;

  currV=targetV;
}


void setupMotion(){
  currX = 0;
  currY = 0;
  currZ = 0;
  currV = 0;
  currT = millis();
  currSpeed = 0;

  targetX = 0;
  targetY = 0;
  targetZ = -10;
  targetV = 0;
}

