
// limits of servo motion for our robot
int minServoPos = -70;
int maxServoPos = 90;

/////////////////////////////////////////////////////////////////////////
/////////////             goTo                 /////////////////////////
//////////////////////////////////////////////////////////////////////////
void goTo( float x0, float y0, float z0 )
{
  float theta1;
  float theta2;
  float theta3;


  // correz=(x0*x0+y0*y0)/8000*5;
  correz=0;
  // loopRangeSensor();

  //vertical=z0+baseZ-correz;
  //vertical=0;
  

  if( 0 != delta_calcInverse( x0,  y0,  z0 + baseZ + correz, theta1, theta2, theta3))
  {
    Serial.println("Value not correct");  
    return; // no pos
  }

  // Serial.print(theta1);Serial.print(theta2);Serial.println(theta3);  
  boolean success = true; 
  success &= transformToServoAngle( theta1 );
  success &= transformToServoAngle( theta2 );
  success &= transformToServoAngle( theta3);


  servoWriteFloat( &servo1, 90-theta1);
  servoWriteFloat( &servo2, 90-theta2+15);
  servoWriteFloat( &servo3, 90-theta3-5); 
  t1=theta1;
  t2=theta2;
  t3=theta3;
}


/////////////////////////////////////////////////////////////////////////
/////////////             trasformToServoAngle   /////////////////////////
//////////////////////////////////////////////////////////////////////////
boolean transformToServoAngle( float &theta )
{
  // Our servos go from 0 (max retract) to 120 (full extend, arm in line with servo body) to 170 (overextended)
  // Theta from the geometry maths has 0 with the arm horizontal, -90 at full extend

  theta = -theta;

  boolean success = true;

  if( theta < minServoPos )
  {
    success = false;
    Serial.print("Theta value not correct:"); 
    Serial.println(theta);
    theta = minServoPos;
  }

  if( theta > maxServoPos )
  {
    success = false;
    Serial.print("Theta value not correct:"); 
    Serial.println(theta);
    theta = maxServoPos; 
  }
  return success;
}




// from http://code.google.com/p/arduino/source/browse/#svn/trunk/libraries/Servo
#define MIN_PULSE_WIDTH       544.0     // the shortest pulse sent to a servo  
#define MAX_PULSE_WIDTH      2400.0     // the longest pulse sent to a servo 


/////////////////////////////////////////////////////////////////////////
/////////////             servoWriteFloat         /////////////////////////
//////////////////////////////////////////////////////////////////////////
// Use writeMicroseconds instead of write() to get more servo resolution, copy conversion formula from Arduino Servo lib source
// This gets us something like ten times the resolution, so we get much smoother motion 
void servoWriteFloat( Servo *s, float angle)
{  

  int uS = MIN_PULSE_WIDTH + angle * ( MAX_PULSE_WIDTH - MIN_PULSE_WIDTH ) / 180.0;      

  s->writeMicroseconds(uS);
}

